#include <bits/stdc++.h>
using namespace std;
int main()
{
    long long n,k,granica=1000000;
    scanf("%lld%lld",&n,&k);
    long long a[n],i,br=0;
    long long ponavljanje[2*granica+1]={0};
    long long resenje[n];
    long long preslok[2*granica+1]={0};
    for(i=0;i<n;i++)
    {
        scanf("%lld",&a[i]);
        if(a[i]==0)
        {
            ponavljanje[a[i]]++;
            if(ponavljanje[a[i]]>=k && preslok[a[i]]==0)
            {
                preslok[a[i]]=1;
                resenje[br]=a[i];
                br++;
            }
        }
        if(a[i]>0)
        {
             ponavljanje[a[i]]++;
            if(ponavljanje[a[i]]>=k && preslok[a[i]]==0)
            {
                preslok[a[i]]=1;
                resenje[br]=a[i];
                br++;
            }
        }
        if(a[i]<0)
        {
            ponavljanje[a[i]+granica]++;
            if(ponavljanje[a[i]+granica]>=k && preslok[a[i]+granica]==0)
            {
                preslok[a[i]+granica]=1;
                resenje[br]=a[i];
                br++;
            }
        }
    }
    printf("%lld\n",br);
    for(i=0;i<br;i++) printf("%lld ",resenje[i]);
    return 0;
}